/**
******************************************************************************
* @file         websocket.c
* @version      V1.0
* @date         2020-06-05
* @brief        websocketЭ飬ȹ
*
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "w5500.h"
#include "socket.h"
#include "sha1.h"
#include "base64.h"
#include "utility.h"
#include "w5500_conf.h"

#define WS_SERVER_PORT  1818    //websocket ˿
uint8  wsTxBuf[2048]={0x00,};   //websocket ͻ
uint8  wsRxBuf[2048]={0x00,};   //websocket ջ

uint16 Srand      = 0;
uint8  handshaked = 0;          //ֳɹ־λ

/**
*@brief  websocketSec-WebSocket-KeySHA1,base64
*@param  
*@return 
*/
void calc_accept_key(char* s, char* r)
{
  int16 i;
  SHA1Context sha;
  const char magicKey[]="258EAFA5-E914-47DA-95CA-C5AB0DC85B11";  //
  char sInput[64]={0x00,};
  char tmpBuf[32]={0x00,};
  strcpy(sInput,s);
  strcpy(sInput+strlen(s),magicKey);
  //printf("input: %s\r\n",sInput);
  SHA1Reset(&sha);
  SHA1Input(&sha, (const unsigned char *)sInput, strlen(sInput));
  if (!SHA1Result(&sha)){
    printf("ERROR-- could not compute message digest\n");
  }else{
    for( i = 0; i < 5 ; i++){
      tmpBuf[i*4+0]=*((char*)&sha.Message_Digest[i]+3);
      tmpBuf[i*4+1]=*((char*)&sha.Message_Digest[i]+2);
      tmpBuf[i*4+2]=*((char*)&sha.Message_Digest[i]+1);
      tmpBuf[i*4+3]=*((char*)&sha.Message_Digest[i]+0);
    }
    for(i=0;i<20;i++)
    //printf("%02X", tmpBuf[i]);
    //printf("\r\n");
    base64encode(tmpBuf,r,20);
  }
}
uint8 temp[1026];             // Ͳ
/**
*@brief  
*@param  
*@return 
*/
void do_websocket_server(void)
{
  uint16 len=0;
  int32 i;
  volatile  uint8 fin;        // 1bit1ʾһ֡
  volatile  uint8 opcode;     // x0ʾframex1ʾıx2ʾƵframe
  uint8 hasmask;              // x1ʾframe룬x0ʾ 
  uint8 payloadlength;        // յĿͻ˵Ϣ
  uint8 extendlength;         // س
  uint8 extend2[2];           // 7bit+2byte
  uint8 extend8[8];           // 7bit+8byte 
  uint8 maskcode[4];          // 4byte
  uint8 masklength; 
  uint32 contentlength;       // ȡĸسȣչݺӦ
  uint8* content;
   switch(getSn_SR(SOCK_WEBSOCKET))
  {
    case SOCK_INIT:       
      listen(SOCK_WEBSOCKET);
      break;
    case SOCK_LISTEN:

      break;
    case SOCK_ESTABLISHED:
      if(getSn_IR(SOCK_WEBSOCKET) & Sn_IR_CON)
      {
         setSn_IR(SOCK_WEBSOCKET, Sn_IR_CON);
        handshaked=0;
      }  
      if(handshaked==1){             // ֳɹж
                                     // ݲ 
              delay_ms(50);                           
            
               temp[0] = 0x81;       // ݰͷ
              temp[1] = rxlen;       // ͵ֽڳ          
              if(rxlen>0){      
               for(i=0;i<rxlen;i++){
                temp[i+2]=rxbuf[i];            
              }                         
              send(SOCK_WEBSOCKET, temp, rxlen+2);
              rxlen = 0;
              memset(temp,0,1026);
              memset(rxbuf,0,1024);
            }       
         
      }
                
      
      if ((len = getSn_RX_RSR(SOCK_WEBSOCKET)) > 0)    
      {
        memset(wsRxBuf,0x00,sizeof(wsRxBuf));                             // websocketջ 
        len = recv(SOCK_WEBSOCKET, wsRxBuf, len); 
        
        if(!handshaked)                                                   // 
        {
          char sec_ws_key[32]={0x00,};
          char accept_key[32]={0x00,};         
  //        printf("WS Rx: %s\r\n",wsRxBuf);
          //get Sec-WebSocket-Key:
          if(strstr((char const*)wsRxBuf,"Sec-WebSocket-Key: "))          // websocketͻְSec-WebSocket-Key״γֵĵַ
          {
            mid((char*)wsRxBuf,"Sec-WebSocket-Key: ","\r\n",sec_ws_key);  // ȡwebsocketͻְSec-WebSocket-Key
   //         printf("----------Sec-WebSocket-Key: %s\r\n",sec_ws_key);
            calc_accept_key(sec_ws_key,accept_key);                       // ȡSec-WebSocket-Key,һmagic string"258EAFA5-E914-47DA-95CA-C5AB0DC85B11"l=ӳһµkey
                                                                          // µkeySH1룬һжλ16ɵļܴ
                                                                          // Ѽܴbase64յkeykeysec-websocket-key
            /*websocket͵websocketͻ*/
            sprintf((char*)wsTxBuf,"HTTP/1.1 101 Switching Protocols\r\nUpgrade: WebSocket\r\nConnection: Upgrade\r\nSec-WebSocket-Accept: %s\r\n\r\n",accept_key);
            send(SOCK_WEBSOCKET,wsTxBuf,strlen((char*)wsTxBuf));
          }
          handshaked=1;                                                   // 
        }else{                                                            // ͻ˵Ϣ                                      
          if(len<2){                                                      // Чͷ 
            printf("Dataframe header invalid!\r\n");
            return;
          }
           //һֽ          
           fin = (wsRxBuf[0] & 0x80) == 0x80;
           opcode = wsRxBuf[0] & 0x0f;
           //ڶֽ
           hasmask = (wsRxBuf[1] & 0x80) == 0x80;
           payloadlength = wsRxBuf[1] & 0x7f;
           extendlength=0;
//           uint8 extend2[2];
//           uint8 extend8[8];
//           uint8 maskcode[4];
            masklength=0;
            contentlength=0;
//           uint8* content;
          
            
          if(payloadlength==126){                      // Чݳ0-125
            memcpy(extend2,wsRxBuf+2,2);
            extendlength=2;
          }else if(payloadlength==127){                // Чݳȴ125
            memcpy(extend8,wsRxBuf+2,8);
            extendlength=8;
          }
            
          if(hasmask){                                 // 봦벻
            memcpy(maskcode,wsRxBuf+extendlength+2,4);
            masklength=4;                              // 4
          }
  
          if(extendlength==0){                         // 7bitȡֵ0-125֮䣬Ǹݳ
            contentlength=payloadlength;
          }else if(extendlength==2){                   // (7bit+2byte)126ʾbyteȡ޷16λֵǸس  
            contentlength=extend2[0]*256+extend2[1];
            if(contentlength>1024*100) contentlength=1024*100;
          }else{                                       // (7bit+8byte)127ʾ8byteȡ64λ޷ֵǸس
            int32 n=1;
            for ( i = 7; i >= 0; i--)
            {
              contentlength += extend8[i] * n;
              n *= 256;
            }
          }
          
          /**/
          content=wsRxBuf+extendlength+masklength+2;
          if(hasmask){                                 //룬Ϊ1-4byteѭbyte
            for(i=0;i<contentlength;i++){
              content[i]=(uint8)(content[i]^maskcode[i%4]);
            }
            printf("Rx: %s\r\n",content);              
          }        
        }       
      }         
      break;
    case SOCK_CLOSE_WAIT:   
      if ((len = getSn_RX_RSR(SOCK_WEBSOCKET)) > 0)
      {        
      }
      disconnect(SOCK_WEBSOCKET);
      break;
    case SOCK_CLOSED:                   
      socket(SOCK_WEBSOCKET, Sn_MR_TCP, WS_SERVER_PORT, 0x20);    // reinitialize the socket 
      break;
    default:
    break;
  }// end of switch
}

